%%%%%%%%%%%%%%%%%%%%%%%
% Anisotropic filtering
% Stphane BAZEILLE
% 15/10/07
%%%%%%%%%%

function diff = anisodiff(im,niter,kappa,lambda,equation)

[rows,cols] = size(im);

diff = im;
%H=fspecial('gaussian',3);
%diff=conv2(diff,H,'same'); 
 
disp(['Anisotropic filtering (',int2str(niter),' stages with equation ',int2str(equation),',kappa =',num2str(kappa),')']);
 
 for i = 1:niter

  % Construct diffl which is the same as diff but has an extra padding of zeros around it.
  diffl = zeros(rows+2, cols+2);
  diffl(2:rows+1, 2:cols+1) = diff;
  
  % diff3 = zeros(rows+2, cols+2);
  % diff3(2:rows+1, 2:cols+1) = diff2;

  % Calcul du gradient
  % North, South, East and West differences
  deltaN = diffl(1:rows,2:cols+1)   - diff;  % [-1 ; 1]
  deltaS = diffl(3:rows+2,2:cols+1) - diff;
  deltaE = diffl(2:rows+1,3:cols+2) - diff;
  deltaW = diffl(2:rows+1,1:cols)   - diff;
  
%  deltaN1 = diff3(1:rows,2:cols+1)   - diff2;  % [-1 ; 1]
%  deltaS1 = diff3(3:rows+2,2:cols+1) - diff2;
%  deltaE1 = diff3(2:rows+1,3:cols+2) - diff2;
%  deltaW1 = diff3(2:rows+1,1:cols)   - diff2;
  
%  deltaN = conv2(deltaN,[1/3;1/3;1/3],'same');
%  deltaS = conv2(deltaS,[1/3;1/3;1/3],'same');
%  deltaE = conv2(deltaE,[1,1,1],'same');
%  deltaW = conv2(deltaW,[1,1,1],'same');
  
%  deltaN = conv2(im,[-1 -1 -1;0 0 0;1 1 1],'same'); % [-1 ; 1]
%  deltaS = conv2(im,[1 1 1;0 0 0;-1 -1 -1],'same');
%  deltaE = conv2(im,[-1 0 1;-1 0 1;-1 0 1],'same');
%  deltaW = conv2(im,[1 0 -1;1 0 -1;1 0 -1],'same');
   
  if (equation==1)
  % Equation 1 : Favours high contrast edges over low contrast ones.
  cN = exp(-((deltaN/kappa).^2));  % [0 ; 1 ] 
  cS = exp(-((deltaS/kappa).^2));
  cE = exp(-((deltaE/kappa).^2));
  cW = exp(-((deltaW/kappa).^2));
  else
  % Equation 2 : Favours wide regions over smaller ones.
  cN = 1./(1+((deltaN/kappa).^2));
  cS = 1./(1+((deltaS/kappa).^2));
  cE = 1./(1+((deltaE/kappa).^2));
  cW = 1./(1+((deltaW/kappa).^2));
  end
  
  diff = diff + lambda*(cN.*deltaN + cS.*deltaS + cE.*deltaE + cW.*deltaW);

end

end









