%%%%%%%%%%%%%%%%%%%%%%
% Constrast stretching
% Stphane BAZEILLE
% 15/10/07
%%%%%%%%%%

function I=contrast_stretching(I)

[rows cols dim]=size(I);

if dim==3
    maxi1=max(max(I(:,:,1)));
    maxi2=max(max(I(:,:,2)));
    maxi3=max(max(I(:,:,3)));
    mini1=min(min(I(:,:,1)));
    mini2=min(min(I(:,:,2)));
    mini3=min(min(I(:,:,3)));
    maxi=max([maxi1,maxi2,maxi3]);
    mini=min([mini1,mini2,mini3]);
    
    if((maxi==1) && (mini==0))
        disp('No contrast stretching required');
    else 
        disp(['Contrast stretching done (',num2str(mini),' ',num2str(maxi),')']);
        for m=1:rows
            for n=1:cols
                I(m,n,1)=(I(m,n,1)-mini1)*1/(maxi1-mini1);
                I(m,n,2)=(I(m,n,2)-mini2)*1/(maxi2-mini2);
                I(m,n,3)=(I(m,n,3)-mini3)*1/(maxi3-mini3);
            end
        end
    end
    
else
    
    maxi=max(max(I));
    mini=min(min(I));
    
    if(maxi==1 && mini==0)
        disp('No contrast stretching required');
    else 
        disp(['Contrast stretching done (',num2str(mini),' ',num2str(maxi),')']);
        for m=1:rows
            for n=1:cols
            I(m,n)=(I(m,n)-mini)*1/(maxi-mini);
            end
        end
    end
end

end