%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% PREFILTER FOR UNDERWATER IMAGES
% Stphane BAZEILLE
% 12/12/07
%%%%%%%%%%

%param: full image name
function prefilter_demo(name)

ori = imread(name);  
ori = double(ori)/255;
disp('Image Loaded');
figure;subplot(1,2,1);imshow(ori);axis off

tic;

disp('BEGIN FILTERING');
% EXTEND AND RESIZE IMAGE
[nl nc I ori]=picture_power_of_2(ori,5);
% CONVERT RGB TO YCBCR
ycbcr = rgb2ycbcr(I);
% HOMOMORPHIC FILTERING
ycbcr(:,:,1)=homomorphic_filtering(ycbcr(:,:,1),'HighPassLiao',2.5,0.5,32);
% WAVELET DENOISING (SELESNICK METHOD)
ycbcr(:,:,1)=denoising_dwt(ycbcr(:,:,1),6,'Farras');
% ANISOTROPIC FILTERING
ycbcr(:,:,1)=anisotropic_filtering(ycbcr(:,:,1),5,0.1,0.1,1);
% CONSTRAST CORRECTION
ycbcr(:,:,1)=suppress_outliers(ycbcr(:,:,1));
ycbcr(:,:,1)=contrast_stretching(ycbcr(:,:,1));
ycbcr(:,:,1)=imadjust(ycbcr(:,:,1),stretchlim(ycbcr(:,:,1),[0.002,0.998]));
% CONVERT YCBCR TO RGB
I = ycbcr2rgb(ycbcr);
% CANCEL SYMETRIC EXTENSION
I = I(floor((512-nl)/2+1):floor(512-(512-nl)/2),floor((512-nc)/2+1):floor(512-(512-nc)/2),:);
% COLOR CORRECTION 
I=egalise_color(I);
disp('END FILTERING');
subplot(1,2,2);imshow(I);axis off

toc;

end