%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% PREFILTER FOR UNDERWATER IMAGES
% Stphane BAZEILLE
% 12/12/07
%%%%%%%%%%

function [ori I]=prefilter_with_block(ori)
     
tic;
disp('BEGIN FILTERING ');

%REDIMENSIONNEMENT DE L'IMAGE
[nl nc I ori]=picture_power_of_2(ori,5);
% RGB->YCR
ycbcr = rgb2ycbcr(I);
% SUPPRESSION DE L'EFFET DE BLOCK PAR FILTRAGE MEDIAN
disp('Suppress block effect');
ycbcr(:,:,1)=medfilt2(ycbcr(:,:,1),[7 7]);
% CORRECTION ECLAIRAGE PAR FILTRAGE HOMOMORPHIQUE
ycbcr(:,:,1)=homomorphic_filtering(ycbcr(:,:,1),'HighPassLiao',2.5,0.5,32);
% DEBRUITAGE PAR SEUILLAGE MULTI ECHELLE DES ONDELLETTES (SELESNICK)
ycbcr(:,:,1)=denoising_dwt(ycbcr(:,:,1),6,'Farras');
% LISSAGE PAR FILTRAGE ANISOTROPIQUE
ycbcr(:,:,1)=anisotropic_filtering(ycbcr(:,:,1),5,0.1,0.1,1);
% CORRECTION CONTRASTE ET NORMALISATION
ycbcr(:,:,1)=suppress_outliers(ycbcr(:,:,1));
ycbcr(:,:,1)=contrast_stretching(ycbcr(:,:,1));
% YCR-> RGB
I = ycbcr2rgb(ycbcr);
% CANCEL SYMETRIC EXTENSION
I = I(floor((512-nl)/2+1):floor(512-(512-nl)/2),floor((512-nc)/2+1):floor(512-(512-nc)/2),:);
% CORRECTION DES COULEURS 
I=egalise_color(I);
      
disp('END FILTERING');
toc;
              
end